//
//
//
#if debugLevelSystemStateMessaging
void printStateFlag(uint8_t sysState, String location) {
    //
    //altSerial.println(location);
    if (sysState == SYSSTATE_IDLE) {
        altSerial.println(F(" Idle"));
    }
    if (sysState & SYSSTATE_ALARM) {
        altSerial.println(F(" Alarm"));
    }
    if (sysState & SYSSTATE_CHECK_MODE) {
        altSerial.println(F(" Check"));
    }
    if (sysState & SYSSTATE_HOMING) {
        altSerial.println(F(" Home"));
    }
    if (sysState & SYSSTATE_CYCLE) {
        altSerial.println(F(" Run"));
    }
    if (sysState & SYSSTATE_HOLD) {
        altSerial.println(F(" Hold"));
    }
    if (sysState & SYSSTATE_JOG) {
        altSerial.println(F(" Jog"));
    }
    if (sysState & SYSSTATE_SAFETY_DOOR) {
        altSerial.println(F(" Door"));
    }
    if (sysState & SYSSTATE_SLEEP) {
        altSerial.println(F(" Sleep"));
    } 
}
#endif

//
//
//
#if debuglevelSystemFlags
void printSysFlags(uint8_t sysFlags, String location) {
    //
    //altSerial.println(location);
    if (sysFlags & SYSFLAGS_NCP) {
        altSerial.println(F(" No Connection Problem"));
    }
    if (sysFlags & SYSFLAGS_HOMEMSG) {
        altSerial.println(F(" HOME Msg from GRBL"));
    }
    if (sysFlags & SYSFLAGS_MALARM) {
        altSerial.println(F(" ALARM: Msg from GRBL"));
    }
    if (sysFlags & SYSFLAGS_JSPRESSED) {
        altSerial.println(F(" JS Button Pressed by User"));
    }
    if (sysFlags & SYSFLAGS_CMP) {
        altSerial.println(F(" Change Menu Flag"));
    }
    if (sysFlags & SYSFLAGS_COORDMODE) {
        altSerial.println(F(" Coordinate Mode Change WPOS/MPOS"));
    }
    if (sysFlags & SYSFLAGS_ALARMACK) {
        altSerial.println(F(" Alarm Acknowledged by User"));
    }
}
#endif

//
//
//
#if debugLevelMachineMovement
void printMovFlags(uint8_t movFlags, String location) {
    //
    //altSerial.println(location);
    if (movFlags & MOVEFLAG_JSL) {
        altSerial.println(F(" JS Move Left"));
    }
    if (movFlags & MOVEFLAG_JSR) {
        altSerial.println(F(" JS Move Right"));
    }
    if (movFlags & MOVEFLAG_JSF) {
        altSerial.println(F(" JS Move Front"));
    }
    if (movFlags & MOVEFLAG_JSB) {
        altSerial.println(F(" JS Move Back"));
    }
    if (movFlags & MOVEFLAG_ROTU) {
        altSerial.println(F(" Rotary Move Up"));
    }
    if (movFlags & MOVEFLAG_ROTD) {
        altSerial.println(F(" Rotary Move Down"));
    }
    if (movFlags & MOVEFLAG_XYAXIS) {
        altSerial.println(F(" Move XY Flag"));
    }
    if (movFlags & MOVEFLAG_ZAXIS) {
        altSerial.println(F(" Move Z Flag"));
    }
}
#endif

//
//
//
#if debugLevelMachineMovement
void printBlinkFlags(uint8_t jogBlinkFlags, String location) {
    //
    //altSerial.println(location);
    if (jogBlinkFlags & JOGBLINK_L) {
        altSerial.print(F(" Blink Left-"));
    }
    if (jogBlinkFlags & JOGBLINK_R) {
        altSerial.print(F(" Blink Right-"));
    }
    if (jogBlinkFlags & JOGBLINK_F) {
        altSerial.print(F(" Blink Front-"));
    }
    if (jogBlinkFlags & JOGBLINK_B) {
        altSerial.print(F(" Blink Back-"));
    }
    if (jogBlinkFlags & JOGBLINK_Z) {
        altSerial.print(F(" Blink Z-"));
    }
    if (jogBlinkFlags & JOGBLINK_5) {
        altSerial.print(F(" 5 - "));
    }
    if (jogBlinkFlags & JOGBLINK_6) {
        altSerial.print(F(" 6 - "));
    }
    
    if (jogBlinkFlags & JOGBLINK_STATE) {
        altSerial.println(F("On"));
    } else {
        altSerial.println(F("Off"));
    }
}
#endif
