//
//
//
void initLEDPins() {
  #if debugLevelProcedureCallTree
    altSerial.println(F("initLEDPins"));
  #endif

  //Setup Tri-Color LED
  pinMode(ledRed, OUTPUT);
  pinMode(ledGreen, OUTPUT);
  pinMode(ledBlue, OUTPUT);
}

//
//
//
void cycleLEDs(int delayPeriod) {
  #if debugLevelProcedureCallTree
    altSerial.println(F("cycleLEDs"));
  #endif

  //LED initialization sequence
  changeLEDColor(ledBlue, toON); 
  delay(delayPeriod);
  changeLEDColor(ledBlue, toOFF);
  delay(delayPeriod);
  changeLEDColor(ledGreen, toON); 
  delay(delayPeriod);
  changeLEDColor(ledGreen, toOFF);
  delay(delayPeriod);
  changeLEDColor(ledRed, toON);
  delay(delayPeriod);
  changeLEDColor(ledRed, toOFF);
  delay(delayPeriod); 
}

//
//
//
void ledMovementState() {
  #if debugLevelProcedureCallTree
    altSerial.println(F("ledMovementState"));
  #endif

  //Blink the blue LED 
  switch (blinkState) {
    case (0): {
      changeLEDColor(ledBlue, toOFF);
      blinkState = 1;
      break;
    }
    case (1): {
      changeLEDColor(ledBlue, toON);
      blinkState = 0;
      break;
    }
  }
  changeLEDColor(ledGreen, toOFF);
  changeLEDColor(ledRed, toOFF);  
}

//
//
//
void ledAlarmState() {
  #if debugLevelProcedureCallTree
    altSerial.println(F("ledAlarmState"));
  #endif

  //Blink the red LED 
  switch (blinkState) {
    case (0): {
      changeLEDColor(ledRed, toOFF);
      blinkState = 1;
      break;
    }
    case (1): {
      changeLEDColor(ledRed, toON);
      blinkState = 0;
      break;
    }
  }
  changeLEDColor(ledBlue, toOFF);
  changeLEDColor(ledGreen, toOFF);
}

//
//
//
void ledAlarmClearState() {
  #if debugLevelProcedureCallTree
    altSerial.println(F("ledAlarmClearState"));
  #endif

  //Blink LED between red and green
  switch (blinkState) {
    case (0): {
      changeLEDColor(ledGreen, toOFF);
      changeLEDColor(ledRed, toON);
      blinkState = 1;
      break;
    }
    case (1): {
      changeLEDColor(ledGreen, toON);
      changeLEDColor(ledRed, toOFF);
      blinkState = 0;
      break; 
    }
  } 
  changeLEDColor(ledBlue, toOFF);
}

//
//
//
void ledStandbyState() {
  #if debugLevelProcedureCallTree
    altSerial.println(F("ledStandbyState"));
  #endif

  //Turn on green LED
  changeLEDColor(ledBlue, toOFF);
  changeLEDColor(ledGreen, toON);
  changeLEDColor(ledRed, toOFF);  
}

//
//
//
void ledHoldState() {
  #if debugLevelProcedureCallTree
    altSerial.println(F("ledHoldState"));
  #endif

  //Blink LED between blue and green
  switch (blinkState) {
    case (0): {
      changeLEDColor(ledBlue, toON);
      changeLEDColor(ledGreen, toOFF);
      blinkState = 1;
      break;
    }
    case (1): {
      changeLEDColor(ledBlue, toOFF);
      changeLEDColor(ledGreen, toON);
      blinkState = 0;
      break; 
    }
  } 
  changeLEDColor(ledRed, toOFF);
}

//
//
//
void ledSleepState() {
  #if debugLevelProcedureCallTree
    altSerial.println(F("ledSleepState"));
  #endif

  //Blink LED between the three colors
  switch (blinkState) {
    case (0): {
      changeLEDColor(ledBlue, toON);
      changeLEDColor(ledGreen, toOFF);
      changeLEDColor(ledRed, toOFF);
      blinkState = 1;
      break;
    }
    case (1): {
      changeLEDColor(ledBlue, toOFF);
      changeLEDColor(ledGreen, toON);
      changeLEDColor(ledRed, toOFF);
      blinkState = 2;
      break;
    }
    case (2): {
      changeLEDColor(ledBlue, toOFF);
      changeLEDColor(ledGreen, toOFF);
      changeLEDColor(ledRed, toON);
      blinkState = 0;
      break;
    }
  }
}

//
//
//
void changeLEDColor(byte ledColor, byte ledState) {
  digitalWrite(ledColor, ledState);
}
