//
//Procedures to Manage all the display pages, menus and the cursor location based upon the selected/active menu item
//

//
// 
//
void updatelcd5110Displays() {
  //Update the displays
  #if debugLevelProcedureCallTree
    altSerial.println(F(" "));
  #endif
  //Update the page with the new data from GRBL.
  if(menuPageActive == Main_L1){ 
    displayMainMenuOptions(false, mainMenuItemSelected, mainMenuItemSelected, false);
  }
  if(menuPageActive == cncOptions_L1){ 
    displayCNCMenuOptions(false, jogMenuItemSelected, jogMenuItemSelected, true);
  }
  if(menuPageActive == Commands_L1){ 
    displayCommandMenuOptions(false, commandsMenuItemSelected, commandsMenuItemSelected, true);
  }
  if(menuPageActive == WPos_L1){ 
    displayWPosMenuOptions(false, wPosMenuItemSelected, wPosMenuItemSelected, true);
  }
  if(menuPageActive == Cutting_L1){ 
    updateCuttingDisplay(false, false);
  }
  if(menuPageActive == Jogging_L1) { 
    updateJoggingDisplay(false, false);
  }
}

//
// SPLASH Screen
//
void displaySplashScreen(boolean clearPage, boolean wrapText, boolean updatePage){
  #if debugLevelProcedureCallTree
    altSerial.println(F("displaySplashScreen"));
  #endif
  //Set the display parameters and text color
  displaySetScreenParms(clearPage);
  changeLEDColor(ledBlue, toON);
  displayPrintText(F("*************"), 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YCoord);
  displayPrintText(F("CBeam-CNC"), 0, 1, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YCoord);
  displayPrintText(F("Arduino"), 0, 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YCoord);
  displayPrintText(F("Joystick"), 0, 3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YCoord);   
  displayPrintText(F("Controller"), 0, 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YCoord); 
  displayPrintText(F("5110****V1.12"), 0, 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YCoord);
  delay(splashScreenDelay);
  changeLEDColor(ledBlue, toOFF);
}

void displayMainMenuOptions(boolean clearPage, mainMenuOptionsVal mainMenuItemSelected, mainMenuOptionsVal previousMainMenuItemSelected, boolean updatePage) {
  #if debugLevelProcedureCallTree
    altSerial.println(F("displayMainMenuOptions"));
  #endif
  //Set the display parameters and text color 
  displaySetScreenParms(clearPage);
  if (updatePage == true) {
    #define mainMenuIndent 12
    #define mainMenuCursorIndent 0
    byte rowNum;
    //mmCommands, mmCncOptions, mmJogging, mmWPos, mmCutting
    displayPrintText(F("Main"), 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XLeftJustified_YLineJustified);
    displayClearChars(6, 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XRightJustified_YLineJustified);
    displayPrintText(returnStateString(), 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XRightJustified_YLineJustified);
    displayPrintText(F("Commands"), mainMenuIndent, 1, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(F("Options"), mainMenuIndent, 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(F("Jogging"), mainMenuIndent,3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(F("Work"), mainMenuIndent, 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(F("Cutting"), mainMenuIndent, 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
  
    returnMainMenuCursorRow(previousMainMenuItemSelected, &rowNum);
    displayClearChars(1, mainMenuCursorIndent, rowNum, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    returnMainMenuCursorRow(mainMenuItemSelected, &rowNum);
    displayPrintText(cursorGlyph, mainMenuCursorIndent, rowNum, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
  } else {  
    updateGRBLState();
 }
  menuPageActive = Main_L1;
}

//
//
//
void returnMainMenuCursorRow(mainMenuOptionsVal mainMenuItem, byte *rowNum){
  //mmCommands, mmCncOptions, mmJogging, mmWPos, mmCutting
  switch (mainMenuItem) {
    case (mmCommands): {
      *rowNum = 1; break;
    }
    case (mmCncOptions): {
      *rowNum = 2; break;
    }
    case (mmJogging): {
      *rowNum = 3; break;
    }
    case (mmWPos): {
      *rowNum = 4; break;
    }
    case (mmCutting): {
      *rowNum = 5; break;
    }
  }
}

void displayCNCMenuOptions(boolean clearPage, jogMenuOptionsVal jogMenuItemSelected, jogMenuOptionsVal previousJogMenuItemSelected, boolean updatePage) {
  #if debugLevelProcedureCallTree
    altSerial.println(F("displayCNCMenuOptions"));
  #endif
  #define mainMenuIndent 12
  #define mainMenuCursorIndent 0
  #define returnIndent mainMenuIndent + 20
  byte rowNum;
  //Set the display parameters and text color 
  displaySetScreenParms(clearPage); //Sets (textWrap, screenColor)
  if (updatePage == true) {  
    displayPrintText(F("Options"), 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XLeftJustified_YLineJustified);
    displayClearChars(6, 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XRightJustified_YLineJustified);
    displayPrintText(returnStateString(), 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XRightJustified_YLineJustified);
    
    displayPrintText(F("ZInc"), mainMenuIndent, 1, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayClearChars(5, (lcd5110Display.width()-(5*dispTextWidth5110*dispTextScale5110)), 1, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(jogZAxisIncrement[jogZAxisIncrementIndex]), (lcd5110Display.width()-(5*dispTextWidth5110*dispTextScale5110)), 1, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);    
  
    displayPrintText(F("ZRate"), mainMenuIndent, 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayClearChars(5, (lcd5110Display.width()-(5*dispTextWidth5110*dispTextScale5110)), 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(feedZAxisIncrement[feedZAxisIncrementIndex]), (lcd5110Display.width()-(5*dispTextWidth5110*dispTextScale5110)), 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord); 
    
    displayPrintText(F("XYInc"), mainMenuIndent, 3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayClearChars(5, (lcd5110Display.width()-(5*dispTextWidth5110*dispTextScale5110)), 3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(jogIncrement[jogIncrementIndex]), (lcd5110Display.width()-(5*dispTextWidth5110*dispTextScale5110)), 3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);  
    
    displayPrintText(F("XYRate"), mainMenuIndent, 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayClearChars(5, (lcd5110Display.width()-(5*dispTextWidth5110*dispTextScale5110)), 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(feedIncrement[feedIncrementIndex]), (lcd5110Display.width()-(5*dispTextWidth5110*dispTextScale5110)), 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);    
    
    displayPrintText(F("Return"), returnIndent, 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YLineJustified);
  
    //Clear the old cursor
    returnCNCMenuOptionsCursorRow(previousJogMenuItemSelected, &rowNum);
    displayClearChars(1, mainMenuCursorIndent, rowNum, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    //Display the new cursor
    returnCNCMenuOptionsCursorRow(jogMenuItemSelected, &rowNum);
    displayPrintText(cursorGlyph, mainMenuCursorIndent, rowNum, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
  } else {
    updateGRBLState();
  }
  menuPageActive = cncOptions_L1;
}

//
//
//
void returnCNCMenuOptionsCursorRow(jogMenuOptionsVal jogMenuItem, byte *rowNum){
  switch (jogMenuItem) {
    case (jmZIncrement): {
      *rowNum = 1; break;
    }
    case (jmZFeed): {
      *rowNum = 2; break;
    }
    case (jmXYIncrement): {
      *rowNum = 3; break;
    }
    case (jmXYFeed): {
      *rowNum = 4; break;
    }
    case (jmReturn): {
      *rowNum = 5; break;
    }
  }
}

void displayCommandMenuOptions(boolean clearPage, commandsMenuOptionsVal commandsMenuItemSelected, commandsMenuOptionsVal previousCommandsMenuItemSelected, boolean updatePage) {
  #if debugLevelProcedureCallTree
    altSerial.println(F("displayCommandMenuOptions"));
  #endif
  #define mainMenuIndent 12
  #define mainMenuCursorIndent 0
  #define returnIndent mainMenuIndent + 20
  byte rowNum;
  //Set the display parameters and text color 
  displaySetScreenParms(clearPage); //Sets (textWrap, screenColor)
  if (updatePage == true) {
    displayPrintText(F("Commands"), 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XLeftJustified_YLineJustified);
    displayClearChars(5, 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XRightJustified_YLineJustified);
    displayPrintText(returnStateString(), 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XRightJustified_YLineJustified);
    displayPrintText(F("Home CNC"), mainMenuIndent, 1, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayClearChars(12, mainMenuIndent, 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(cmd1Strings[cmd1StringsIndex]), mainMenuIndent, 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayClearChars(7, mainMenuIndent, 3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(cmd2Strings[cmd2StringsIndex]), mainMenuIndent, 3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayClearChars(8, mainMenuIndent, 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(cmd3Strings[cmd3StringsIndex]), mainMenuIndent, 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);   
    displayPrintText(F("Return"), returnIndent, 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
  
    //Clear the old cursor
    returnCommandMenuOptionsCursorRow(previousCommandsMenuItemSelected, &rowNum);
    displayClearChars(1, mainMenuCursorIndent, rowNum, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    //Display the new cursor
    returnCommandMenuOptionsCursorRow(commandsMenuItemSelected, &rowNum);
    displayPrintText(cursorGlyph, mainMenuCursorIndent, rowNum, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
  } else {
    updateGRBLState();
  }
  menuPageActive = Commands_L1;
}

//
//
//
void returnCommandMenuOptionsCursorRow(commandsMenuOptionsVal commandsMenuItem, byte *rowNum){
  switch (commandsMenuItem) {
    case (coHome): {
      *rowNum = 1; break;
    }
    case (coSleepWake): {
      *rowNum = 2; break;
    }
    case (coHoldResume): {
      *rowNum = 3; break;
    }
    case (coAbortResetUnlock): {
      *rowNum = 4; break;
    }
    case (coReturn): {
      *rowNum = 5; break;
    }
  }
}

void displayWPosMenuOptions(boolean clearPage, wPosMenuOptionsVal wPosMenuItemSelected, wPosMenuOptionsVal previousWPosMenuItemSelected, boolean updatePage) {
  #if debugLevelProcedureCallTree
    altSerial.println(F("displayWPosMenuOptions"));
  #endif
  #define mainMenuIndent 12
  #define mainMenuCursorIndent 0
  #define returnIndent mainMenuIndent + 20
  byte rowNum;
  //Set the display parameters and text color 
  displaySetScreenParms(clearPage); //Sets (textWrap, screenColor)
  if (updatePage == true) {
    //wpSetXYzero, wpSetZzero, wpHome, wpZSafe, wpReturn
    displayPrintText(F("Work"), 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XLeftJustified_YLineJustified);
    displayClearChars(6, 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XRightJustified_YLineJustified);
    displayPrintText(returnStateString(), 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XRightJustified_YLineJustified);
    displayPrintText(F("Set X0Y0"), mainMenuIndent, 1, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(F("Set Z0"), mainMenuIndent, 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(F("Home XY0ZS"), mainMenuIndent, 3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText("ZSafe", mainMenuIndent, 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayClearChars(5, (lcd5110Display.width()-(6*dispTextWidth5110*dispTextScale5110)), 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(zSafeIncrement[zSafeIncrementIndex]), (lcd5110Display.width()-(6*dispTextWidth5110*dispTextScale5110)), 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);    
    displayPrintText(F("Return"), returnIndent, 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord); 
  
    //Clear the old cursor
    returnWPosMenuOptionsCursorRow(previousWPosMenuItemSelected, &rowNum);
    displayClearChars(1, mainMenuCursorIndent, rowNum, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    //Display the new cursor
    returnWPosMenuOptionsCursorRow(wPosMenuItemSelected, &rowNum);
    displayPrintText(cursorGlyph, mainMenuCursorIndent, rowNum, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
  } else {
    updateGRBLState();
  }
  menuPageActive = WPos_L1;
}

//
//
//
void returnWPosMenuOptionsCursorRow(wPosMenuOptionsVal wPosMenuItem, byte *rowNum){
  //wpSetXYzero, wpSetZzero, wpHome, wpZSafe, wpReturn
  switch (wPosMenuItem) {
    case (wpSetXYzero): {
      *rowNum = 1; break;
    }
    case (wpSetZzero): {
      *rowNum = 2; break;
    }
    case (wpHome): {
      *rowNum = 3; break;
    }
    case (wpZSafe): {
      *rowNum = 4; break;
    }
    case (wpReturn): {
      *rowNum = 5; break;
    }
  }
}

void updateJoggingDisplay(boolean clearPage, boolean updatePage) {
  #if debugLevelProcedureCallTree
    altSerial.println(F("updateJoggingDisplay"));
  #endif
  #define mainMenuIndent 12
  byte rowNum;
  //Set the display parameters and text color 
  displaySetScreenParms(clearPage); //Sets (textWrap, screenColor)
  if (updatePage == true) {
    displayPrintText(F("Jogging"), 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XLeftJustified_YLineJustified);
    displayClearChars(6, 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XRightJustified_YLineJustified);
    displayPrintText(returnStateString(), 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XRightJustified_YLineJustified);
    displayPrintText(F("-Y"), mainMenuIndent, 1, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YLineJustified);
    displayPrintText(F("-X"), (1*dispTextWidth5110*dispTextScale5110), 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(F("Z"), 0, 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YLineJustified);
    displayPrintText(F("+X"), (lcd5110Display.width()-(3*dispTextWidth5110*dispTextScale5110)), 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(F("+Y"), mainMenuIndent, 3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YLineJustified);
  
    displayPrintText(F(" Z"), 0, 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XLeftJustified_YLineJustified);
    displayClearChars(4, (3*dispTextWidth5110*dispTextScale5110), 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(jogZAxisIncrement[jogZAxisIncrementIndex]), (3*dispTextWidth5110*dispTextScale5110), 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(F("@"), (lcd5110Display.width()-(6*dispTextWidth5110*dispTextScale5110)), 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayClearChars(4, (lcd5110Display.width()-(4*dispTextWidth5110*dispTextScale5110)), 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(feedZAxisIncrement[feedZAxisIncrementIndex]), (lcd5110Display.width()-(4*dispTextWidth5110*dispTextScale5110)), 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
  
    displayPrintText(F("XY"), 0, 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XLeftJustified_YLineJustified);
    displayClearChars(4, (3*dispTextWidth5110*dispTextScale5110), 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(jogIncrement[jogIncrementIndex]), (3*dispTextWidth5110*dispTextScale5110), 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(F("@"), (lcd5110Display.width()-(6*dispTextWidth5110*dispTextScale5110)), 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayClearChars(4, (lcd5110Display.width()-(4*dispTextWidth5110*dispTextScale5110)), 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(feedIncrement[feedIncrementIndex]), (lcd5110Display.width()-(4*dispTextWidth5110*dispTextScale5110)), 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
  } else {
    updateGRBLState();    
    if (sysState == SYSSTATE_JOG) {
      updateJoggingBlink();   
    } else {
      displayPrintText(F("-X"), (1*dispTextWidth5110*dispTextScale5110), 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
      displayPrintText(F("+X"), (lcd5110Display.width()-(3*dispTextWidth5110*dispTextScale5110)), 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
      displayPrintText(F("+Y"), mainMenuIndent, 3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YLineJustified);
      displayPrintText(F("-Y"), mainMenuIndent, 1, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YLineJustified);
      displayPrintText(F("Z"), 0, 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YLineJustified);
    }
  }
  menuPageActive = Jogging_L1;
}

void updateJoggingBlink() { 

  if (bit_istrue(jogBlinkFlags, JOGBLINK_Z)) {
    if (bit_isfalse(jogBlinkFlags, JOGBLINK_STATE)) {
      displayPrintText(F("Z"), 0, 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YLineJustified);
      bit_true(jogBlinkFlags, JOGBLINK_STATE);
    } else {
      displayClearChars(2, mainMenuIndent, 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YLineJustified);
      bit_false(jogBlinkFlags, JOGBLINK_STATE);      
    }
  } else {
    displayPrintText(F("Z"), 0, 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YLineJustified);
  } 
  
  if (bit_istrue(jogBlinkFlags, JOGBLINK_L)) {
    if (bit_isfalse(jogBlinkFlags, JOGBLINK_STATE)) {
      displayPrintText(F("-X"), (1*dispTextWidth5110*dispTextScale5110), 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
      bit_true(jogBlinkFlags, JOGBLINK_STATE);
    } else {
      displayClearChars(2, (1*dispTextWidth5110*dispTextScale5110), 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
      bit_false(jogBlinkFlags, JOGBLINK_STATE);
    }
  } else {
    displayPrintText(F("-X"), (1*dispTextWidth5110*dispTextScale5110), 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
  }
  
  if (bit_istrue(jogBlinkFlags, JOGBLINK_R)) {
    if (bit_isfalse(jogBlinkFlags, JOGBLINK_STATE)) {
      displayPrintText(F("+X"), (lcd5110Display.width()-(3*dispTextWidth5110*dispTextScale5110)), 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
      bit_true(jogBlinkFlags, JOGBLINK_STATE);
    } else {
      displayClearChars(2, (lcd5110Display.width()-(3*dispTextWidth5110*dispTextScale5110)), 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
      bit_false(jogBlinkFlags, JOGBLINK_STATE);
    }
  } else {
    displayPrintText(F("+X"), (lcd5110Display.width()-(3*dispTextWidth5110*dispTextScale5110)), 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
  }
  
  if (bit_istrue(jogBlinkFlags, JOGBLINK_F)) {
    if (bit_isfalse(jogBlinkFlags, JOGBLINK_STATE)) {
      displayPrintText(F("+Y"), mainMenuIndent, 3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YLineJustified);
      bit_true(jogBlinkFlags, JOGBLINK_STATE);
    } else {
      displayClearChars(2, mainMenuIndent, 3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YLineJustified);
      bit_false(jogBlinkFlags, JOGBLINK_STATE);
    }
  } else {
    displayPrintText(F("+Y"), mainMenuIndent, 3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YLineJustified);
  }
  
  if (bit_istrue(jogBlinkFlags, JOGBLINK_B)) {
    if (bit_isfalse(jogBlinkFlags, JOGBLINK_STATE)) {
      displayPrintText(F("-Y"), mainMenuIndent, 1, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YLineJustified);
      bit_true(jogBlinkFlags, JOGBLINK_STATE);
    } else {
      displayClearChars(2, mainMenuIndent, 1, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YLineJustified);
      bit_false(jogBlinkFlags, JOGBLINK_STATE);
    }
  } else {
    displayPrintText(F("-Y"), mainMenuIndent, 1, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCenterJustified_YLineJustified);
  }
}

void updateCuttingDisplay(boolean clearPage, boolean updatePage) {
  #if debugLevelProcedureCallTree
    altSerial.println(F("updateCuttingDisplay"));
  #endif
  #define mainMenuCursorIndent 10
  //Set the display parameters and text color 
  displaySetScreenParms(clearPage); //Sets (textWrap, screenColor)
  if (updatePage == true) {
    displayPrintText(F("Cutting"), 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XLeftJustified_YLineJustified);
    displayClearChars(6, 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XRightJustified_YLineJustified);
    displayPrintText(returnStateString(), 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XRightJustified_YLineJustified);
    displayPrintText(F("MPOS"), mainMenuCursorIndent-6, 1, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(F("XPos"), mainMenuCursorIndent, 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(F("YPos"), mainMenuCursorIndent, 3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(F("ZPos"), mainMenuCursorIndent, 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(F("F"), mainMenuCursorIndent-6, 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
  } else {
    //Update the display with the latest GRBL data
    //Re-init the display every displayCNCDataUpdateCounterMax cycles - cleans up garbage they may have crept in over time...
    if (displayCNCDataUpdateCounter > displayCNCDataUpdateCounterMax) {
      updateCuttingDisplay(true, true);
      displayCNCDataUpdateCounter = 0;
    } else {
      displayCNCDataUpdateCounter++;
    }
    updateGRBLState();
        
    displayClearChars(6, mainMenuCursorIndent-6, 1, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText((bit_isfalse(sysFlags, SYSFLAGS_COORDMODE) ? "MPos" : "WPos"), mainMenuCursorIndent-6, 1, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    
    displayClearChars(8, (lcd5110Display.width()-(8*dispTextWidth5110*dispTextScale5110)), 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(fxPos), (lcd5110Display.width()-(8*dispTextWidth5110*dispTextScale5110)), 2, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayClearChars(8, (lcd5110Display.width()-(8*dispTextWidth5110*dispTextScale5110)), 3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(fyPos), (lcd5110Display.width()-(8*dispTextWidth5110*dispTextScale5110)), 3, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayClearChars(8, (lcd5110Display.width()-(8*dispTextWidth5110*dispTextScale5110)), 4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(fzPos), (lcd5110Display.width()-(8*dispTextWidth5110*dispTextScale5110)),4, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
  
    displayClearChars(4, (3*dispTextWidth5110*dispTextScale5110), 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    displayPrintText(String(feedRate), (3*dispTextWidth5110*dispTextScale5110), 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
  
    if (pinStatesLength > 0) {
      displayClearChars(pinStatesLength+1, (lcd5110Display.width()-((pinStatesLength+1)*dispTextWidth5110*dispTextScale5110)), 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
      displayPrintText(pinStates, (lcd5110Display.width()-((pinStatesLength)*dispTextWidth5110*dispTextScale5110)), 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    } else {
      displayClearChars(5, (lcd5110Display.width()-(5*dispTextWidth5110*dispTextScale5110)), 5, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XCoord_YCoord);
    }    
  }
  menuPageActive = Cutting_L1;
}

//
//
//
void updateGRBLState() {
  displayClearChars(6, 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XRightJustified_YLineJustified);
  displayPrintText(returnStateString(), 0, 0, dispTftTextRowHeightPadding, dispTextScale5110, dispTextScale5110, text_XRightJustified_YLineJustified);
}
