//
//Procedure to Manage the cursor movement and menu selected item within the menu items on the menu pages
//
void manageMenuJSMovements() {
  #if debugLevelProcedureCallTree
    altSerial.println(F("manageMenuJSMovements"));
  #endif

    //User wants to move in the menu either up or down on the displayed page or right into the next menu level
    //Switch on the current displayed page
    switch (menuPageActive) {
      case (Main_L1): {
        switch (mainMenuItemSelected) {
          //mmCommands, mmCncOptions, mmJogging, mmWPos, mmCutting
          case (mmCommands): {
            previousMainMenuItemSelected = mmCommands;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {mainMenuItemSelected = mmCutting;} else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {mainMenuItemSelected = mmCncOptions;} 
            if (bit_istrue(movFlags, MOVEFLAG_JSR)) {displayCommandMenuOptions(true, commandsMenuItemSelected, commandsMenuItemSelected, true);}
            break;
          }
          case (mmCncOptions): {
            previousMainMenuItemSelected = mmCncOptions;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {mainMenuItemSelected = mmCommands; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {mainMenuItemSelected = mmJogging;} 
            if (bit_istrue(movFlags, MOVEFLAG_JSR)) {displayCNCMenuOptions(true, jogMenuItemSelected, jogMenuItemSelected, true);}
            break;
          }
          case (mmJogging): {
            previousMainMenuItemSelected = mmJogging;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {mainMenuItemSelected = mmCncOptions;} else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {mainMenuItemSelected = mmWPos;} 
            if (bit_istrue(movFlags, MOVEFLAG_JSR)) {updateJoggingDisplay(true, true); bit_true(sysFlags,SYSFLAGS_CMP);}
            break;  
          }          
          case (mmWPos): {
            previousMainMenuItemSelected = mmWPos;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {mainMenuItemSelected = mmJogging;} else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {mainMenuItemSelected = mmCutting;} 
            if (bit_istrue(movFlags, MOVEFLAG_JSR)) {displayWPosMenuOptions(true, wPosMenuItemSelected, wPosMenuItemSelected, true);}
            break;
          }
          case (mmCutting): {
            previousMainMenuItemSelected = mmCutting;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {mainMenuItemSelected = mmWPos;} else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {mainMenuItemSelected = mmCommands;} 
            if (bit_istrue(movFlags, MOVEFLAG_JSR)) {updateCuttingDisplay(true, true);}
            break;
          }
        }
        if (movFlags & (MOVEFLAG_JSF | MOVEFLAG_JSB)) { //Re-display this menu 
          displayMainMenuOptions(false, mainMenuItemSelected, previousMainMenuItemSelected, true); //Re-display the menu
        }
        break;  
      }      
      case (cncOptions_L1): {
        switch (jogMenuItemSelected) {
          //jmZIncrement, jmZFeed, jmXYIncrement, jmXYFeed, jmReturn
          case (jmZIncrement): {
            previousJogMenuItemSelected = jmZIncrement;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {jogMenuItemSelected = jmReturn; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {jogMenuItemSelected = jmZFeed;} 
            break;
          }
          case (jmZFeed): {
            previousJogMenuItemSelected = jmZFeed;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {jogMenuItemSelected = jmZIncrement; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {jogMenuItemSelected = jmXYIncrement;} 
            break;
          }
          case (jmXYIncrement): {
            previousJogMenuItemSelected = jmXYIncrement;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {jogMenuItemSelected = jmZFeed; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {jogMenuItemSelected = jmXYFeed;} 
            break;
          }
          case (jmXYFeed): {
            previousJogMenuItemSelected = jmXYFeed;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {jogMenuItemSelected = jmXYIncrement; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {jogMenuItemSelected = jmReturn;} 
            break;
          }
          case (jmReturn): {
            previousJogMenuItemSelected = jmReturn;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {jogMenuItemSelected = jmXYFeed; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {jogMenuItemSelected = jmZIncrement;} 
            if (bit_istrue(movFlags, MOVEFLAG_JSR)) {displayMainMenuOptions(true, mainMenuItemSelected, mainMenuItemSelected, true);}
            break;
          }
        }  
        if (movFlags & (MOVEFLAG_JSF | MOVEFLAG_JSB)) { //Re-display this menu
          displayCNCMenuOptions(false, jogMenuItemSelected, previousJogMenuItemSelected, true); //Re-display the menu
        }
        break;  
      }    
      case (Commands_L1): {
        switch (commandsMenuItemSelected) {
          //coHome, coSleepWake, coHoldResume, coAbortResetUnlock, coReturn
          case (coHome): {
            previousCommandsMenuItemSelected = coHome;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {commandsMenuItemSelected = coReturn; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {commandsMenuItemSelected = coSleepWake;} 
            break;
          }
          case (coSleepWake): {
            previousCommandsMenuItemSelected = coSleepWake;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {commandsMenuItemSelected = coHome; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {commandsMenuItemSelected = coHoldResume;} 
            break;
          }
          case (coHoldResume): {
            previousCommandsMenuItemSelected = coHoldResume;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {commandsMenuItemSelected = coSleepWake; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {commandsMenuItemSelected = coAbortResetUnlock;} 
            break;
          }
          case (coAbortResetUnlock): {
            previousCommandsMenuItemSelected = coAbortResetUnlock;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {commandsMenuItemSelected = coHoldResume; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {commandsMenuItemSelected = coReturn;} 
            break;
          }
          case (coReturn): {
            previousCommandsMenuItemSelected = coReturn;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {commandsMenuItemSelected = coAbortResetUnlock; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {commandsMenuItemSelected = coHome;} 
            if (bit_istrue(movFlags, MOVEFLAG_JSR)) {displayMainMenuOptions(true, mainMenuItemSelected, mainMenuItemSelected, true);}
            break;
          }
        }  
        if (movFlags & (MOVEFLAG_JSF | MOVEFLAG_JSB)) { //Re-display this menu
          displayCommandMenuOptions(false, commandsMenuItemSelected, previousCommandsMenuItemSelected, true); //Re-display the menu
        }
        break;    
      }
      case (WPos_L1): {
        switch (wPosMenuItemSelected) {
          //wpSetXYzero, wpSetZzero, wpHome, wpZSafe, wpReturn
          case (wpSetXYzero): {
            previousWPosMenuItemSelected = wpSetXYzero;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {wPosMenuItemSelected = wpReturn; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {wPosMenuItemSelected = wpSetZzero;} 
            break;
          }
          case (wpSetZzero): {
            previousWPosMenuItemSelected = wpSetZzero;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {wPosMenuItemSelected = wpSetXYzero; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {wPosMenuItemSelected = wpHome;} 
            break;
          }
          case (wpHome): {
            previousWPosMenuItemSelected = wpHome;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {wPosMenuItemSelected = wpSetZzero; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {wPosMenuItemSelected = wpZSafe;} 
            break;
          }
          case (wpZSafe): {
            previousWPosMenuItemSelected = wpZSafe;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {wPosMenuItemSelected = wpHome; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {wPosMenuItemSelected = wpReturn;} 
            break;
          }
          case (wpReturn): {
            previousWPosMenuItemSelected = wpReturn;
            if (bit_istrue(movFlags, MOVEFLAG_JSF)) {wPosMenuItemSelected = wpZSafe; } else if (bit_istrue(movFlags, MOVEFLAG_JSB)) {wPosMenuItemSelected = wpSetXYzero;} 
            if (bit_istrue(movFlags, MOVEFLAG_JSR)) {displayMainMenuOptions(true, mainMenuItemSelected, mainMenuItemSelected, true);}
            break;
          }
        }  
        if (movFlags & (MOVEFLAG_JSF | MOVEFLAG_JSB)) { //Re-display this menu
          displayWPosMenuOptions(false, wPosMenuItemSelected, previousWPosMenuItemSelected, true); //Re-display the menu
        }
        break;
      }
    }
}

//
//Procedure to Manage the selection of a menu item on a page via the button press (CLICK) of the joystick
//Allows the user to move around the menu pages and select menu items to perform actions associated to that menu item
//Selecting the menu via the button click of the joystick is the same as using the right direction movement of the joystick
//
void manageMenuJSButtonPress() {
  #if debugLevelProcedureCallTree
    altSerial.println(F("manageMenuJSButtonPress"));
  #endif

  // Check if the user has pressed the joystick button
  if (bit_istrue(sysFlags,SYSFLAGS_JSPRESSED)) {
    //User pressed the switch down on the joystick - clear the switch press
    bit_false(sysFlags,SYSFLAGS_JSPRESSED);
    //Switch on the current displayed page
    switch (menuPageActive) {
         
      case (Main_L1): {
        //altSerial.println(F("Page-Main"));
        switch (mainMenuItemSelected) {
          //mmCncOptions, mmJogging, mmCutting, mmCommands
          case (mmCncOptions): {
            //Display the Jog Options page
            displayCNCMenuOptions(true, jogMenuItemSelected, jogMenuItemSelected, true);
            break;
          }
          case (mmJogging): {
            //Display the Jogging page
            updateJoggingDisplay(true, true);
            break;   
          }         
          case (mmCutting): {
             //Display the Cutting page
             updateCuttingDisplay(true, true);
             break;
          }
          case (mmCommands): {
            //Display the Commands page
            displayCommandMenuOptions(true, commandsMenuItemSelected, commandsMenuItemSelected, true);
            break;  
          }      
          case (mmWPos): {
            //Display the WPos page
            displayWPosMenuOptions(true, wPosMenuItemSelected, wPosMenuItemSelected, true);
            break;
          }
        }
        break;
      }
      case (cncOptions_L1): {
        //altSerial.println(F("Page-Options"));
        switch (jogMenuItemSelected) {
          //jmZIncrement, jmXYIncrement, jmXYFeed, jmJogging, jmReturn
          case (jmZIncrement): {
            //Increment is selected by moving the joystick left to right
            //Nothing else to do here for the moment
            break;     
          }     
          case (jmZFeed): {
            //Feed Rate is selected by moving the joystick left to right
            //Nothing else to do here for the moment
            break; 
          }
          case (jmXYIncrement): {
            //Increment is selected by moving the joystick left to right
            //Nothing else to do here for the moment
            break;
          }
          case (jmXYFeed): {
            //Feed Rate is selected by moving the joystick left to right
            //Nothing else to do here for the moment
            break;
          }
          case (jmReturn): {
            displayMainMenuOptions(true, mainMenuItemSelected, mainMenuItemSelected, true);
            break;
          }
        }  
        break;
      }
      case (Commands_L1): {
        //altSerial.println(F("Page-Cmds"));
        switch (commandsMenuItemSelected) {
          //coHome, coSleepWake, coHoldResume, coAbortResetUnlock, coReturn
          case (coHome): {
            sendMessageToGRBL(txTransmitOnOpenTimeShort, cmdHomingCycle);
            break;
          }
          case (coSleepWake): {
            switch (cmd1StringsIndex) {
              case (0):  {//Sleep           
                sendMessageToGRBL(txTransmitOnOpenTimeShort, cmdSleepMode); //Goto Sleep
                break;
              }
              case (1):  { //Wake Up
                sendCharMessageToGRBL(txTransmitOnOpenTimeShort, cmdSoftReset); //Soft reset to wake up Ctrl-x
                sendMessageToGRBL(txTransmitOnOpenTimeShort, cmdKillAlarmLock); //Unlock
                break;
              }
            }
            displayCommandMenuOptions(false, commandsMenuItemSelected, commandsMenuItemSelected, true);
            break;
          }
          case (coHoldResume): {
            switch (cmd2StringsIndex) {
              case (0):  { //Hold
                signalGRBLInterfacePin(txSignalPinOnTime, feedHoldInterfacePin); //Send Feed Hold signal to GRBL
                break;
              }
              case (1):  {//Resume
                signalGRBLInterfacePin(txSignalPinOnTime, cycleStartResumeInterfacePin); //Send Cycle Start/Resume signal to GRBL
                break;
              }
            }            
            displayCommandMenuOptions(false, commandsMenuItemSelected, commandsMenuItemSelected, true);
            break;
          }
          case (coAbortResetUnlock): {
            switch (cmd3StringsIndex) {
              case (0):  { //Abort           
                signalGRBLInterfacePin(txSignalPinOnTime, resetAbortInterfacePin); //Signal pin - Reset Abort
                break;
              }
              case (1): { //Reset
                sendCharMessageToGRBL(txTransmitOnOpenTimeShort, cmdSoftReset); //Soft reset to wake up Ctrl-x
                break;
              }
              case (2): { //Unlock
                sendMessageToGRBL(txTransmitOnOpenTimeShort, cmdKillAlarmLock); //Unlock
                break;
              }
            }              
            displayCommandMenuOptions(false, commandsMenuItemSelected, commandsMenuItemSelected, true);            
            break;
          }
          case (coReturn): {
            displayMainMenuOptions(true, mainMenuItemSelected, mainMenuItemSelected, true);
            break;
          }
        }  
        break;
      }
      case (Jogging_L1): {
        //altSerial.println(F("Page-Jogging"));
        //Send cancel message to GRBL - assumes user wanted to cancel the jog in process by clicking the joystick button.
        //If no jog in process the command will be ignored by GRBL
        sendCharMessageToGRBL(txTransmitOnOpenTimeShort, cmdJogCancel);   
        jogMenuItemSelected = jmReturn; //Default to return selected menu item
        displayCNCMenuOptions(true, jogMenuItemSelected, jogMenuItemSelected, true);
        break;
      }
      case (Cutting_L1): {
        //altSerial.println(F("Page-Cutting"));
        displayMainMenuOptions(true, mainMenuItemSelected, mainMenuItemSelected, true);
        break;
      }
      case (WPos_L1): {
        //altSerial.println(F("Page-WPos"));
        String homeToWPOS = "G90G01X0Y0"; //Home to work position home location X=0, Y=0, Z=ZSafe
        String wPosSetXYZero = "G90G10L20P01X0Y0"; //Set as current tool position X=0, Y=0
        String wPosSetZZero = "G90G10L20P01Z0"; //Set as current tool position Z=0
        switch (wPosMenuItemSelected) {
          //wpSetXYzero, wpSetZzero, wpHome, wpZSafe, wpReturn
          case (wpSetXYzero): {
            //Set the Work Position home location - typically X=0, Y=0
            bit_true(movFlags, MOVEFLAG_XYAXIS);
            movementCommandString = wPosSetXYZero + "\n";
            break;
          }
          case (wpSetZzero): {
            //Set the Work Position home location - typically Z=0
            bit_true(movFlags, MOVEFLAG_XYAXIS);
            movementCommandString = wPosSetZZero + "\n";
            break;
          }
          case (wpHome): {
            //Go to the Work Position home location - typically X=0, Y=0, Z=zSafe
            bit_true(movFlags, MOVEFLAG_XYAXIS);
            movementCommandString = homeToWPOS + "Z" + zSafeIncrement[zSafeIncrementIndex] + "F" + feedIncrement[feedIncrementIndex] + "\n";
            break;
          }
          case (wpZSafe):  {
            //Z Safe is selected by moving the joystick left to right
            //Nothing else to do here for the moment
            break;
          }
          case (wpReturn): {
            displayMainMenuOptions(true, mainMenuItemSelected, mainMenuItemSelected, true);
            break;
          }
        }  
        break;
      }
      case (NCP_Alarm_L1): { //No Connection Problem
        //altSerial.println(F("Page-NCP"));
        bit_true(sysFlags,SYSFLAGS_ALARMACK); //Alarm acknowledged
        bit_false(sysFlags,SYSFLAGS_NCP); //Clear the flag
        displayMainMenuOptions(true, mainMenuItemSelected, mainMenuItemSelected, true);
        break;
      }
      case (MAS_Alarm_L1): { //Machine Alarm State
        //altSerial.println(F("Page-MAS"));
        bit_true(sysFlags,SYSFLAGS_ALARMACK); //Alarm acknowledged
        displayMainMenuOptions(true, mainMenuItemSelected, mainMenuItemSelected, true);
        break;
      }
      case (HOME_Alarm_L1): { //Homing Cycle State
        //altSerial.println(F("Page-Home"));
        bit_true(sysFlags,SYSFLAGS_ALARMACK); //Alarm acknowledged
        displayMainMenuOptions(true, mainMenuItemSelected, mainMenuItemSelected, true);
        break;
      }
    }    
  }
}

//
//Procedure to Manage the selectable menu items using the joystick - with a left or right movement - click the joystick button to select the menu item
//  or move the joystick to the right to enter that menu item
//
void manageMenuJSParamsSelect() {
  #if debugLevelProcedureCallTree
    altSerial.println(F("manageMenuJSParamsSelect"));
  #endif

  //Update the selectable items based upon the user JS movement left to right
  //Update the the value on the screen
  switch (menuPageActive) {
    case (Main_L1): {
      switch (mainMenuItemSelected) {
        //mmCncOptions, mmJogging, mmCutting, mmCommands
        case (mmCncOptions): {
          //Nothing else to do here for the moment
          break;
        }
        case (mmJogging): {
          //Nothing else to do here for the moment
          break;    
        }        
        case (mmCutting): {
          //Nothing else to do here for the moment
          break;
        }
        case (mmCommands): {
          //Nothing else to do here for the moment
          break;  
        }      
        case (mmWPos): {
          //Nothing else to do here for the moment
          break;
        }
      }
      break;
    }
    case (cncOptions_L1): {
      switch (jogMenuItemSelected) {
        case (jmZIncrement): {
          if(bit_istrue(movFlags, MOVEFLAG_XYAXIS)) {
            if (bit_istrue(movFlags, MOVEFLAG_JSL)) {
              if (jogZAxisIncrementIndex > 0) { jogZAxisIncrementIndex--; } else { jogZAxisIncrementIndex = 0;}         
            } else if (bit_istrue(movFlags, MOVEFLAG_JSR)) {
              if (jogZAxisIncrementIndex < maxZAxisJogIncrements - 1) { jogZAxisIncrementIndex++; } else { jogZAxisIncrementIndex = maxZAxisJogIncrements - 1; }                        
            }
            displayCNCMenuOptions(false, jogMenuItemSelected, jogMenuItemSelected, true);
          }
          break;
        }       
        case (jmZFeed): {
          if(bit_istrue(movFlags, MOVEFLAG_XYAXIS)) {
            if (bit_istrue(movFlags, MOVEFLAG_JSL)) {
              if (feedZAxisIncrementIndex > 0) { feedZAxisIncrementIndex--; } else { feedZAxisIncrementIndex = 0;}         
            } else if (bit_istrue(movFlags, MOVEFLAG_JSR)) {
              if (feedZAxisIncrementIndex < maxZAxisFeedIncrements - 1) { feedZAxisIncrementIndex++; } else { feedZAxisIncrementIndex = maxZAxisFeedIncrements - 1; }                        
            }
            displayCNCMenuOptions(false, jogMenuItemSelected, jogMenuItemSelected, true);
          }
          break;
        }
        case (jmXYIncrement): {
          if(bit_istrue(movFlags, MOVEFLAG_XYAXIS)) {
            if (bit_istrue(movFlags, MOVEFLAG_JSL)) {
              if (jogIncrementIndex > 0) { jogIncrementIndex--; } else { jogIncrementIndex = 0;}         
            } else if (bit_istrue(movFlags, MOVEFLAG_JSR)) {
              if (jogIncrementIndex < maxJogIncrements - 1) { jogIncrementIndex++; } else { jogIncrementIndex = maxJogIncrements - 1; }                        
            }
            displayCNCMenuOptions(false, jogMenuItemSelected, jogMenuItemSelected, true);
          }
          break;
        }
        case (jmXYFeed): {
          if(bit_istrue(movFlags, MOVEFLAG_XYAXIS)) {
            if (bit_istrue(movFlags, MOVEFLAG_JSL)) {
              if (feedIncrementIndex > 0) { feedIncrementIndex--; } else { feedIncrementIndex = 0;}         
            } else if (bit_istrue(movFlags, MOVEFLAG_JSR)) {
              if (feedIncrementIndex < maxFeedIncrements - 1) { feedIncrementIndex++; } else { feedIncrementIndex = maxFeedIncrements - 1; }                        
            }
            displayCNCMenuOptions(false, jogMenuItemSelected, jogMenuItemSelected, true);
          }
          break;
        }
        case (jmReturn): {
          //Nothing else to do here for the moment
          break;
        }
      }
      break;
    }
    case (WPos_L1): {
      switch (wPosMenuItemSelected) {
        case (wpZSafe): {
          if(bit_istrue(movFlags, MOVEFLAG_XYAXIS)) {
            if (bit_istrue(movFlags, MOVEFLAG_JSL)) {
              if (zSafeIncrementIndex > 0) { zSafeIncrementIndex--; } else { zSafeIncrementIndex = 0;}         
            } else if (bit_istrue(movFlags, MOVEFLAG_JSR)) {
              if (zSafeIncrementIndex < maxzSafeIncrements - 1) { zSafeIncrementIndex++; } else { zSafeIncrementIndex = maxzSafeIncrements - 1; }                        
            }
            displayWPosMenuOptions(false, wPosMenuItemSelected, wPosMenuItemSelected, true);
          }
          break;
        }
        case (wpReturn): {
          //Nothing else to do here for the moment
          break;
        }
      }  
      break;
    }
    case (Commands_L1): {
      switch (commandsMenuItemSelected) {
        //coSleepWake, coHoldResume, coAbortResetUnlock
        case (coSleepWake): {
          if(bit_istrue(movFlags, MOVEFLAG_XYAXIS)) {
            if (bit_istrue(movFlags, MOVEFLAG_JSL)) {
              if (cmd1StringsIndex > 0) { cmd1StringsIndex--; } else { cmd1StringsIndex = 0;}         
            } else if (bit_istrue(movFlags, MOVEFLAG_JSR)) {
              if (cmd1StringsIndex < maxCmd1Strings - 1) { cmd1StringsIndex++; } else { cmd1StringsIndex = maxCmd1Strings - 1; }                        
            }
            displayCommandMenuOptions(false, commandsMenuItemSelected, commandsMenuItemSelected, true);
          }
          break; 
        }        
        case (coHoldResume): {
          if(bit_istrue(movFlags, MOVEFLAG_XYAXIS)) {
            if (bit_istrue(movFlags, MOVEFLAG_JSL)) {
              if (cmd2StringsIndex > 0) { cmd2StringsIndex--; } else { cmd2StringsIndex = 0;}         
            } else if (bit_istrue(movFlags, MOVEFLAG_JSR)) {
              if (cmd2StringsIndex < maxCmd2Strings - 1) { cmd2StringsIndex++; } else { cmd2StringsIndex = maxCmd2Strings - 1; }                        
            }
            displayCommandMenuOptions(false, commandsMenuItemSelected, commandsMenuItemSelected, true);
          }
          break;
        }        
        case (coAbortResetUnlock): {
          if(bit_istrue(movFlags, MOVEFLAG_XYAXIS)) {
            if (bit_istrue(movFlags, MOVEFLAG_JSL)) {
              if (cmd3StringsIndex > 0) { cmd3StringsIndex--; } else { cmd3StringsIndex = 0;}         
            } else if (bit_istrue(movFlags, MOVEFLAG_JSR)) {
              if (cmd3StringsIndex < maxCmd3Strings - 1) { cmd3StringsIndex++; } else { cmd3StringsIndex = maxCmd3Strings - 1; }                        
            }
            displayCommandMenuOptions(false, commandsMenuItemSelected, commandsMenuItemSelected, true);
          }
          break;
        }
        case (coReturn): {
          //Nothing else to do here for the moment
         break;
        }
      }  
      break;
    }
  }
}
